
module Repoaccessor

	require "json"

	class KV_pair
		attr_accessor :key
		attr_accessor :value
		attr_accessor :comment

		def initialize(key,value,comment)
			@key = key
			@value = value
			@comment = comment
		end
		

		def to_hash
			{
				:key => @key,
				:value => @value,
				:comment => @comment
			}
			
		end
		
	end


	class XMLFile
		attr_accessor :kv_pairs

		def initialize
			@kv_pairs = []
		end

		def key_values
			#TODO:不影响主功能 
		end

		def keys
			#TODO:不影响主功能 
		end

		def values
			#TODO:不影响主功能 
		end

		def to_hash(args={})
     		with_comments = args[:with_comments].nil? ? true : args[:with_comments]
			build_hash { |hash, pair|
     			hash_value = with_comments ? { pair.value => pair.comment } : pair.value
        		hash[pair.key] = hash_value
      		}
		end

		def to_json
			self.to_hash(:with_comments => false).to_json
		end

		def build_hash(&block)
	        hash = {}
	        @kv_pairs.each do |pair|
	          yield hash, pair
	        end
	        hash
     	end
		
	end
	
end

